#! /usr/bin/env python

#Universidad Nacional Autonoma de Mexico
#PAPIME PE 400216
#DGAPA
#Programacion y diseno: Hadassa Amelia Juarez Hernandez. 2016 Attributions in /attributions
#Uncommented version

#kip es deslizar en maya: http://www.mayas.uady.mx/diccionario/k_maya.html

import os
import re
import sys
import string
import random
import pygame
import marshal
from pygame.color import *

from pygame.locals import *
from menu.Items import Bonus, Collect, GameOver, Timer, Word, WordsHeader

pygame.init()
pygame.display.set_caption("Kip German Chapter 3 Papime PE 400216 UNAM")
screen = pygame.display.set_mode([800,650])

FONT = os.path.join('fonts', 'subtitulos.TTF')
subtitulos = os.path.join('fonts', 'subtitulos.TTF')
Titulo = os.path.join('fonts', 'Titulos.TTF')
texto = os.path.join('fonts', 'texto.TTF')

idioma=0
colorElse = [255,255,255]
if idioma == 0:
	fondo = pygame.image.load('Images/English.jpg').convert()
	colorElse = [0,0,0]

Bfondo = pygame.transform.smoothscale(fondo, (800,650))
portada = pygame.transform.smoothscale(fondo, (800,650))

screentype = 'principal'

class Game:
	def __init__(self):
		self.game_over = 0

		self.prev_x = 0
		self.prev_y = 0
		self.last_click = 0

		file = open(os.path.join('Palabras','palabras.txt'), 'r')
		self.wordlist = file.readlines()
		
		for i in range(len(self.wordlist)):
			self.wordlist[i] = string.replace(self.wordlist[i], "\n", "")

	def create_grid(self):
		positions = [
			'100,100', '150,100', '200,100', '250,100', '300,100', '350,100', '400,100', '450,100',
			'100,150', '150,150', '200,150', '250,150', '300,150', '350,150', '400,150', '450,150',
			'100,200', '150,200', '200,200', '250,200', '300,200', '350,200', '400,200', '450,200',
			'100,250', '150,250', '200,250', '250,250', '300,250', '350,250', '400,250', '450,250',
			'100,300', '150,300', '200,300', '250,300', '300,300', '350,300', '400,300', '450,300',
			'100,350',   '150,350',   '200,350',   '250,350',   '300,350',   '350,350',   '400,350',   '450,350',
			'100,400',  '150,400',  '200,400',  '250,400',  '300,400',  '350,400',  '400,400',  '450,400',
			'100,450', '150,450', '200,450', '250,450', '300,450', '350,450', '400,450', '450,450',
		]

		random.shuffle(positions)
		positions.pop()
		positions.pop()
		positions.pop()
		positions.pop()
		positions.pop()
		positions.pop()
		positions.pop()
		positions.pop()
		positions.pop()
		positions.pop()
		positions.pop()
		positions.pop()
		positions.pop()
		positions.pop()
		positions.pop()
		
		for i in range(2):
			for word in self.target_words:
				for letter in word:
					x,y = positions.pop().split(',')
					self.tiles.add(Tile( letter, [int(x),int(y)] ))

		for pos in positions:
			x,y = pos.split(',')
			self.tiles.add(Tile( self.letters[ random.randrange(len(self.letters)) ], [int(x),int(y)] ))

	def demo_mode(self):

		color = colorElse
		
		font0 = pygame.font.Font(Titulo, 90)
		text0 = font0.render("Kip", 1, color)
		
		font1 = pygame.font.Font(subtitulos, 27)
		text1 = font1.render("Jugar",1,color)
		
		font2 = pygame.font.Font(subtitulos,15)
		
		screen.blit(portada, (0, 0))
		screen.blit(text0, (330,90))
		screen.blit(text1, (365, 240))
		
		pygame.display.flip()

		in_demo=1
		while in_demo:
			for event in pygame.event.get():
				if event.type == QUIT:
					sys.exit()
				elif event.type == MOUSEBUTTONDOWN:
					in_demo=0
				else:
					pass
		self.start()

	def double_clicked(self,x,y):
		time_now = pygame.time.get_ticks()
		pause = time_now - self.last_click
	
		if self.prev_x == x and self.prev_y == y:
			if pause <= 300:
				return 1
	
		self.prev_x     = x
		self.prev_y     = y
		self.last_click = time_now

		return 0

	
	def remove_tile(self,pos):
		self.marker.rect[0] = pos[0]
		self.marker.rect[1] = pos[1]
		rectlist = pygame.sprite.spritecollide(self.marker,self.tiles,1)
		pygame.display.update(rectlist)
		pygame.time.wait(50)

	def pick_words(self):
		self.target_words = []
		for i in range(1):
			self.target_words.append(self.wordlist[random.randrange(len(self.wordlist))])
        
		self.words_to_find = []
		self.words_to_find.append(Word(self.target_words[0],[530,330]))

		for word in self.words_to_find:
			self.gamesprites.add(word)

	def reset(self):
		self.game_over = 0
		self.bonus.reset()

		self.gamesprites.remove(self.bonus)

		for word in self.words_to_find:
			self.gamesprites.remove(word)

	def restart(self):
		self.tiles.empty()

		self.reset()
		self.timer.reset()
		self.score.reset()

		self.gamesprites.remove(self.bonus)
		self.menusprites.remove(self.game_over_menu)


		self.letters = [ 'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z' ]

		self.run()

	def run(self):
		self.timer.start()
		self.pick_words()
		self.create_grid()
		self.score.calculate(self.tiles, self.target_words)

		pygame.event.set_allowed(None)
		pygame.event.set_allowed([QUIT,MOUSEBUTTONDOWN,MOUSEMOTION,MOUSEBUTTONUP])
		
		start_tile = None
		end_tile = None
		moveable = 1
		moved = False
		while 1:
			for event in pygame.event.get():
				if event.type == QUIT:
					sys.exit()

				elif event.type == MOUSEBUTTONDOWN:
					moved = False
					moveable = 1
					x,y = pygame.mouse.get_pos()
					starting_clicked_area = pygame.Rect(x,y,1,1)
		
					for tile in self.tiles.sprites():
						if starting_clicked_area.colliderect(tile.rect):
							start_tile = tile

					if self.double_clicked(x,y) and start_tile:
						for direction in ['up','down','left','right']:
							if not moveable:
								break
							if direction == 'up':
								neighbour_x = start_tile.rect[0]
								neighbour_y = start_tile.rect[1]-50
							elif direction == 'down':
								neighbour_x = start_tile.rect[0]
								neighbour_y = start_tile.rect[1]+50
							elif direction == 'left':
								neighbour_x = start_tile.rect[0]-50
								neighbour_y = start_tile.rect[1]
							elif direction == 'right':
								neighbour_x = start_tile.rect[0]+50
								neighbour_y = start_tile.rect[1]

							if neighbour_x < 100 or neighbour_y < 100:
								continue
                    
							elif neighbour_x > 450 or neighbour_y > 450:
								continue

							neighbour = pygame.Rect(neighbour_x,neighbour_y,1,1)

							for tile in self.tiles.sprites():
								if neighbour.colliderect(tile.rect):
									end_tile = tile

							if not end_tile:
								moveable = 0
								start_tile.move([neighbour_x,neighbour_y])
		
							end_tile = None

				elif event.type == MOUSEMOTION:
					try:
						if moveable:
							x,y = pygame.mouse.get_pos()
                            
							if x < 100:
								x = 100
							if x > 450:
								x = 450
							if y < 100:
								y = 100
							if y > 450:
								y = 450
							finishing_dragged_area = pygame.Rect(x,y,10,10)
			
							for tile in self.tiles.sprites():
								if finishing_dragged_area.colliderect(tile.rect):
									end_tile = tile
									break

							if x > start_tile.rect[0]+75:
								pass
							elif y > start_tile.rect[1]+75:
								pass
							elif start_tile.fixed:
								pass
							elif start_tile and not end_tile:
								start_tile.move([x,y])
								moved = True

							end_tile = None
					except:
						pass

				elif event.type == MOUSEBUTTONUP:
					if moved:
						x,y = pygame.mouse.get_pos()
						self.found_words = self.score.calculate(self.tiles, self.target_words,0)

					self.collect.click_test()
					
					start_tile = None
					end_tile = None
					moveable = 0

			self.tiles.update()
			self.score.update()
			self.gamesprites.update()
			self.menusprites.update()

			if self.bonus.off_screen:
				self.bonus.reset()
				self.gamesprites.remove(self.bonus)

			if self.collect.clicked and not self.game_over:
				self.found_words = self.score.calculate(self.tiles, self.target_words)

				for word in self.found_words:
					self.timer.timer = self.timer.timer + 25

				words = ", ".join(self.found_words)

				if len(words) > 0:
					self.bonus.award(words)
					self.gamesprites.add(self.bonus)
				else:
					self.bonus.award("-5 seconds!")
					self.gamesprites.add(self.bonus)

				if self.timer.timer > 120:
					self.timer.timer = 120

				for sprite in self.tiles.sprites():
					self.remove_tile(sprite.rect)

				for word in self.words_to_find:
					self.gamesprites.remove(word)

				for i in range(len(self.found_words)):
					2+2

				#tiempo de penalizacion
				if not self.found_words:
					self.timer.timer = self.timer.timer - 10

				self.collect.clicked = 0

				self.pick_words()
				self.create_grid()
				self.font = pygame.font.Font(FONT, 30)
				self.score.calculate(self.tiles, self.target_words)

			if self.timer.time_up():
				self.timer.stop()

				for sprite in self.tiles.sprites():
					self.remove_tile(sprite.rect)
				
				self.game_over = 1
				pygame.time.delay(5000)
				break
				
			if not self.game_over:
				tile_list = self.tiles.draw(self.screen)
				pygame.display.update(tile_list)

			ui_list = self.gamesprites.draw(self.screen)
			pygame.display.update(ui_list)
			menu_list = self.menusprites.draw(self.screen)
			pygame.display.update(menu_list)

			pygame.time.delay(10)
			self.tiles.clear(self.screen, self.background)
			self.gamesprites.clear(self.screen, self.background)
			self.menusprites.clear(self.screen, self.background)

	def start(self):
		self.screen = pygame.display.set_mode([800,650])
		self.background = Bfondo
		self.screen.blit(self.background, [0, 0])
		pygame.display.update()

		self.marker = Tile('a',[0,0])

		self.bonus = Bonus()
		self.score = Score()
		self.timer = Timer()
		self.collect = Collect(self)

		self.words_header = WordsHeader()
		self.game_over_menu = GameOver(self)

		self.tiles = pygame.sprite.RenderUpdates()
		self.gamesprites = pygame.sprite.RenderUpdates()
		self.menusprites = pygame.sprite.RenderUpdates()
		self.letters = [ 'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z' ]

		self.gamesprites.add(self.score)
		self.gamesprites.add(self.timer)
		self.gamesprites.add(self.words_header)

		self.menusprites.add(self.collect)

		self.run()

class Score(pygame.sprite.Sprite):
	def __init__(self):
		pygame.sprite.Sprite.__init__(self)

		self.score = 0
		self.tile_groups = {}
	
	def calculate(self,board,targets,award_score=1):
		all_words = []
		found_words = []
		self.word_tiles = []
		self.found_tiles = {}

		self.board = board
		self.targets = targets
		self.time_bonus = 0

		# Left to right, right to left
		all_words.append(self.traverse_grid(0,451,50))
		all_words.append(self.traverse_grid(450,-1,-50))
		# Up and down, down and up
		all_words.append(self.traverse_grid(0,451,50,1))
		all_words.append(self.traverse_grid(450,-1,-50,1))

		regexes = []
		for target in self.targets:
			regexes.append(re.compile(target))

		length = 0
		tmp_word = False
		for words in all_words:
			for word in words:
				if not word:
					continue
				for regex in regexes:
					match = regex.search(word)
					if match:
						if match.group() not in found_words and match.group() != "":
							found_words.append(match.group())

							tmp_word = match.group() 
							pos = word.find(tmp_word)
							length = len(tmp_word)

							for i in range(length):
								rect = self.found_tiles[word][pos+i].rect
								self.found_tiles[word][pos+i].image = pygame.image.load('images/otrasletras/%s.jpg' % self.found_tiles[word][pos+i].letter).convert()
								self.found_tiles[word][pos+i].fixed = True

							if award_score:
								self.score = self.score+(len(word)*10)

		return found_words

	def reset(self):
		self.score = 0

	def traverse_grid(self,row,column,step,vertical=0):
		if vertical:
			prev_x = column
			prev_y = row
		else:
			prev_x = row
			prev_y = column

		tile = None
		found_words = []
		for y in range(row,column,step):
			word = []
			tiles = []
			for x in range(row,column,step):
				if vertical:
					current_tile = pygame.Rect(y,x,1,1)
				else:
					current_tile = pygame.Rect(x,y,1,1)

				for sprite in self.board.sprites():
					if current_tile.colliderect(sprite.rect):
						tile = sprite
						if x > (prev_x+50) or y > (prev_y+50):
							found_words.append("".join(word))
							self.found_tiles["".join(word)] = tiles
							word = []
							tiles = []
							word.append(tile.letter)
							tiles.append(tile)
						elif x < (prev_x-50) or y < (prev_y-50):
							found_words.append("".join(word))
							self.found_tiles["".join(word)] = tiles
							word = []
							tiles = []
							word.append(tile.letter)
							tiles.append(tile)
						else:
							word.append(tile.letter)
							tiles.append(tile)
						prev_x = x
						prev_y = y
			found_words.append("".join(word))
			self.found_tiles["".join(word)] = tiles

		return found_words
            
	def update(self):
		self.color = colorElse
		self.font = pygame.font.Font(FONT, 40)
		self.image = self.font.render("Score: %d" % self.score, 1, self.color)
		self.rect = self.image.get_rect()
		self.rect = self.rect.move([530,160])

class Tile(pygame.sprite.Sprite):
	def __init__(self,letter,pos):
		pygame.sprite.Sprite.__init__(self)

		self.fixed = False
		self.letter = letter

		self.image = pygame.image.load('images/letras/%s.jpg' % letter).convert()
		self.rect = self.image.get_rect()
		self.rect = self.rect.move(pos)

	def move(self,pos):

		x = pos[0] - (pos[0] % 50)
		y = pos[1] - (pos[1] % 50)

		if x > self.rect[0] or y > self.rect[1]:
			if x > self.rect[0] + 50 or y > self.rect[1] + 50:
				return None

		if x < self.rect[0] or y < self.rect[1]:
			if x < self.rect[0] - 50 or y < self.rect[1] - 50:
				return None

		if ( x > self.rect[0] and y > self.rect[1] ) or ( x < self.rect[0] and y < self.rect[1] ):
			return None

		if ( x > self.rect[0] and y < self.rect[1] ) or ( x < self.rect[0] and y > self.rect[1] ):
			return None

		self.rect[0] = x
		self.rect[1] = y

if __name__ == '__main__':
	Game = Game()
	Game.demo_mode()
